<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__pdmpcm_8h" kind="file" language="C++">
    <compoundname>cyhal_pdmpcm.h</compoundname>
    <includes local="no">stdbool.h</includes>
    <includes local="no">stddef.h</includes>
    <includes local="no">stdint.h</includes>
    <includes local="yes" refid="cyhal__general__types_8h">cyhal_general_types.h</includes>
    <includes local="yes" refid="cyhal__hw__types_8h">cyhal_hw_types.h</includes>
    <includes local="yes" refid="cyhal__pin__package_8h">cyhal_pin_package.h</includes>
    <includes local="yes" refid="cyhal__syspm_8h">cyhal_syspm.h</includes>
    <includedby local="yes" refid="cyhal__drivers_8h">cyhal_drivers.h</includedby>
    <includedby local="yes" refid="cyhal__pdmpcm_8c">cyhal_pdmpcm.c</includedby>
    <incdepgraph>
      <node id="194">
        <label>stdbool.h</label>
      </node>
      <node id="196">
        <label>stdint.h</label>
      </node>
      <node id="195">
        <label>stddef.h</label>
      </node>
      <node id="193">
        <label>cyhal_pdmpcm.h</label>
        <link refid="cyhal__pdmpcm_8h" />
        <childnode refid="194" relation="include">
        </childnode>
        <childnode refid="195" relation="include">
        </childnode>
        <childnode refid="196" relation="include">
        </childnode>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</innerclass>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__results__pdmpcm_1gab471f70db994ab16530c558581c77eb3" kind="define" prot="public" static="no">
        <name>CYHAL_PDM_PCM_RSLT_ERR_INVALID_PIN</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005a52c9005959fa8236fc262a990d3bd48f">CYHAL_RSLT_MODULE_PDMPCM</ref>, 0))</initializer>
        <briefdescription>
<para>The pin PDM/PCM hardware cannot be initialized with the passed in pin. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="100" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="100" />
      </memberdef>
      <memberdef id="group__group__hal__results__pdmpcm_1ga3cc92f16488e35fe3ea1cdf25cfabf00" kind="define" prot="public" static="no">
        <name>CYHAL_PDM_PCM_RSLT_ERR_INVALID_CONFIG_PARAM</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005a52c9005959fa8236fc262a990d3bd48f">CYHAL_RSLT_MODULE_PDMPCM</ref>, 1))</initializer>
        <briefdescription>
<para>A configuration parameter is invalid: sample_rate, decimation_rate, PCM word length, left/right gain. </para>        </briefdescription>
        <detaileddescription>
<para>See the implementation specific documentation for valid range </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="104" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="104" />
      </memberdef>
      <memberdef id="group__group__hal__results__pdmpcm_1ga2ad85ab6a3b273a585179c75474fe1a3" kind="define" prot="public" static="no">
        <name>CYHAL_PDM_PCM_RSLT_ERR_ASYNC_IN_PROGRESS</name>
        <initializer>(CYHAL_RSLT_CREATE(<ref kindref="member" refid="group__group__result_1ga8d656d344524464af71296f2140a7b37">CY_RSLT_TYPE_ERROR</ref>, <ref kindref="member" refid="group__group__hal__results_1gga84f32ecb6376e2088d4f048e35f52005a52c9005959fa8236fc262a990d3bd48f">CYHAL_RSLT_MODULE_PDMPCM</ref>, 2))</initializer>
        <briefdescription>
<para>An async read operation is already progres. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="107" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="107" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_pdm_pcm_event_t</name>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a23cdac0a9d48999fd992d2b6ec0c6d46" prot="public">
          <name>CYHAL_PDM_PCM_RX_HALF_FULL</name>
          <initializer>= 0x01</initializer>
          <briefdescription>
<para>RX hardware buffer is half full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a7d033c3845dfddec84d445d36dfc6cd1" prot="public">
          <name>CYHAL_PDM_PCM_RX_NOT_EMPTY</name>
          <initializer>= 0x02</initializer>
          <briefdescription>
<para>RX hardware buffer is not empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a1f4fabcea8eab0bcaa83e790bc9bf9d7" prot="public">
          <name>CYHAL_PDM_PCM_RX_OVERFLOW</name>
          <initializer>= 0x04</initializer>
          <briefdescription>
<para>Attempt to write to a full RX hardware buffer. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a96b6aab4d2062870825335c3eb08ce7d" prot="public">
          <name>CYHAL_PDM_PCM_RX_UNDERFLOW</name>
          <initializer>= 0x08</initializer>
          <briefdescription>
<para>Attempt to read from an empty buffer. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc" prot="public">
          <name>CYHAL_PDM_PCM_ASYNC_COMPLETE</name>
          <initializer>= 0x10</initializer>
          <briefdescription>
<para>Async operation completed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_pdm_pcm_event_t: </bold><linebreak />PDM/PCM interrupt triggers.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="121" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="115" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="115" />
      </memberdef>
      <memberdef id="group__group__hal__pdmpcm_1gac81a68ee166ff48752095f82e6852565" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_pdm_pcm_mode_t</name>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a9b6dc0fbdb5ff94c50d3ea447b2e7729" prot="public">
          <name>CYHAL_PDM_PCM_MODE_LEFT</name>
          <briefdescription>
<para>The channel mono left. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a10f63e46718c10aefbc64bfda8b82cfd" prot="public">
          <name>CYHAL_PDM_PCM_MODE_RIGHT</name>
          <briefdescription>
<para>The channel mono right. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a3422b29a54a23f1133a62c2b566196dc" prot="public">
          <name>CYHAL_PDM_PCM_MODE_STEREO</name>
          <briefdescription>
<para>The channel stereo. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_pdm_pcm_mode_t: </bold><linebreak />PDM/PCM channel select.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="128" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="124" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="124" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_pdm_pcm_event_callback_t) (void *handler_arg, cyhal_pdm_pcm_event_t event)</definition>
        <argsstring>)(void *handler_arg, cyhal_pdm_pcm_event_t event)</argsstring>
        <name>cyhal_pdm_pcm_event_callback_t</name>
        <briefdescription>
<para>Handler for PDM/PCM interrupts. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="142" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="142" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gac2baa0d5162498463cc5228e0ab70909" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_init</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_gpio_t pin_data, cyhal_gpio_t pin_clk, const cyhal_clock_t *clk_source, const cyhal_pdm_pcm_cfg_t *cfg)</argsstring>
        <name>cyhal_pdm_pcm_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin_data</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin_clk</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk_source</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Initialize the PDM/PCM peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>Configures the pins used by PDM/PCM converter, sets a default format and frequency, and enables the peripheral <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a PDM/PCM object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for PDM input </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin_clk</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for PDM clock output </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk_source</parametername>
</parameternamelist>
<parameterdescription>
<para>The clock source for PDM/PCM block </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>The configuration for the PDM/PCM block </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="534" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="446" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="155" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga89ce18cbdd29884ea093ea413df76c6f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_free</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Release a PDM/PCM object, behavior is undefined if an asynchronous read is in progress. </para>        </briefdescription>
        <detaileddescription>
<para>Return the peripheral, pins and clock owned by the PDM/PCM object to their reset state <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to deinitialize </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="558" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="536" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="163" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_start</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_start</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Start the PDM/PCM operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to start </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the status of the start request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="575" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="560" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="171" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gae3832916c19f3031dddcee394047e499" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_stop</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_stop</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Stop the PDM/PCM operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to start </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the status of the stop request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="582" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="577" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="179" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga70af22e5c029ef0899d14da93253fcc1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_pdm_pcm_is_enabled</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_is_enabled</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified PDM/PCM peripheral is enabled (regardless of whether any unread data has been received). </para>        </briefdescription>
        <detaileddescription>
<para>The PDM/PCM peripheral can be enabled by calling <ref kindref="member" refid="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61">cyhal_pdm_pcm_start</ref> and disabled by calling <ref kindref="member" refid="group__group__hal__pdmpcm_1gae3832916c19f3031dddcee394047e499">cyhal_pdm_pcm_stop</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S receive function is enabled. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="588" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="584" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="190" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gad2dc5543b500a97a938d6c642932e772" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_set_gain</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, int8_t gain_left, int8_t gain_right)</argsstring>
        <name>cyhal_pdm_pcm_set_gain</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>int8_t</type>
          <declname>gain_left</declname>
        </param>
        <param>
          <type>int8_t</type>
          <declname>gain_right</declname>
        </param>
        <briefdescription>
<para>Updates the PDM/PCM channel gains. </para>        </briefdescription>
        <detaileddescription>
<para>Each integer increment represent a 0.5 dB value. For example: a gain value of 5 would mean +2.5 dB. If the exact gain value requested is not supported, it will be rounded to the nearest legal value. See the implementation specific documentation for valid ranges.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Gains may be negative if the implementation supports it.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to configure </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gain_left</parametername>
</parameternamelist>
<parameterdescription>
<para>The gain of the left channel in units of 0.5 dB </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gain_right</parametername>
</parameternamelist>
<parameterdescription>
<para>The gain of the right channel in units of 0.5 dB </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set gain operation. An error will be returned if the value is outside of range supported by HW. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="601" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="590" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="204" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga4f6559e37a2ea3facdffe3cac6241356" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_clear</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_clear</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Clears the hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the clear request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="608" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="603" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="211" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga5694092b3f4bc66a0a649829d346d1c7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_read</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, void *data, size_t *length)</argsstring>
        <name>cyhal_pdm_pcm_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t *</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Reads data synchronously. </para>        </briefdescription>
        <detaileddescription>
<para>This will read either length words or the number of words that are currently available in the receive buffer, whichever is less, then return. The value pointed to by length will be updated to reflect the number of words that were actually read. If there are less data in FIFO than length, length will be update with number of words read.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to word array where incoming data will be stored. Buffer must be aligned to word-size. Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bits. Negative value will use sign-extension. -1 with 24-bit word length will have 32-bit value of 0xFFFFFFFF. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of 32-bit words to read, updated with the number actually read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="641" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="610" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="228" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_read_async</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, void *data, size_t length)</argsstring>
        <name>cyhal_pdm_pcm_read_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Begin asynchronous PDM/PCM read. </para>        </briefdescription>
        <detaileddescription>
<para>This will transfer length words into the buffer pointed to by data in the background. When the requested quantity of data has been read, the <ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc">CYHAL_PDM_PCM_ASYNC_COMPLETE</ref> event will be raised. See <ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref> and <ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref>.</para><para>cyhal_pdm_pcm_set_async_mode can be used to control whether this uses DMA or a CPU-driven transfer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to word array where incoming data will be stored. Buffer must be aligned to word-size. Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bits. Negative value will use sign-extension. -1 with 24-bit word length will have 32-bit value of 0xFFFFFFFF. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of words to read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="697" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="643" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="246" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga9510e6cfe34d3279aaa2fcf015e24288" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_pdm_pcm_is_pending</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_is_pending</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if an async read operation is pending. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Indication of whether a PDM/PCM async operation is pending </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="703" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="699" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="253" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga5db8d3906cdd3cd0e2cadcb6a283d910" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_abort_async</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_abort_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort an PDM/PCM operation started by cyhal_pdm_pcm_read_async function. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral to stop </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="718" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="705" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="260" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_register_callback</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_pdm_pcm_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_pdm_pcm_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198">cyhal_pdm_pcm_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register a PDM/PCM event handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt fires </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="726" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="720" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="270" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_enable_event</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_pdm_pcm_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_pdm_pcm_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure PDM/PCM event enablement. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on events, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="755" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="728" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="279" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga2296229eed2643ba0a938c3437c6ce82" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_set_async_mode</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_async_mode_t mode, uint8_t dma_priority)</argsstring>
        <name>cyhal_pdm_pcm_set_async_mode</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1gab2d2acfb82599df54152be0b170c6ec2">cyhal_async_mode_t</ref></type>
          <declname>mode</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>dma_priority</declname>
        </param>
        <briefdescription>
<para>Set the mechanism that is used to perform PDM/PCM asynchronous operation. </para>        </briefdescription>
        <detaileddescription>
<para>The default is SW.</para><para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>The transfer mode </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dma_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority, if DMA is used. Valid values are the same as for <ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>. If DMA is not selected, the only valid value is CYHAL_DMA_PRIORITY_DEFAULT, and no guarantees are made about prioritization. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set mode request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="783" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="757" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="292" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Provides a high level interface for interacting with the Cypress PDM/PCM. </para>    </briefdescription>
    <detaileddescription>
<para>This interface abstracts out the chip specific details. If any chip specific functionality is necessary, or performance is critical the low level functions can be used directly.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="79"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /></codeline>
<codeline lineno="81"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdbool.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stddef.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal" /><highlight class="preprocessor">#include<sp />&lt;stdint.h&gt;</highlight><highlight class="normal" /></codeline>
<codeline lineno="84"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_general_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_hw_types.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_pin_package.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_syspm.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="90"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="91"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="100"><highlight class="preprocessor">#define<sp />CYHAL_PDM_PCM_RSLT_ERR_INVALID_PIN<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="101"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_PDMPCM,<sp />0))</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal" /></codeline>
<codeline lineno="104"><highlight class="preprocessor">#define<sp />CYHAL_PDM_PCM_RSLT_ERR_INVALID_CONFIG_PARAM<sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="105"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_PDMPCM,<sp />1))</highlight><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="preprocessor">#define<sp />CYHAL_PDM_PCM_RSLT_ERR_ASYNC_IN_PROGRESS<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="108"><highlight class="preprocessor"><sp /><sp /><sp /><sp />(CYHAL_RSLT_CREATE(CY_RSLT_TYPE_ERROR,<sp />CYHAL_RSLT_MODULE_PDMPCM,<sp />2))</highlight><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal" /></codeline>
<codeline lineno="115"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a23cdac0a9d48999fd992d2b6ec0c6d46">CYHAL_PDM_PCM_RX_HALF_FULL</ref><sp /><sp /><sp />=<sp />0x01,<sp /></highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a7d033c3845dfddec84d445d36dfc6cd1">CYHAL_PDM_PCM_RX_NOT_EMPTY</ref><sp /><sp /><sp />=<sp />0x02,<sp /></highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a1f4fabcea8eab0bcaa83e790bc9bf9d7">CYHAL_PDM_PCM_RX_OVERFLOW</ref><sp /><sp /><sp /><sp />=<sp />0x04,<sp /></highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a96b6aab4d2062870825335c3eb08ce7d">CYHAL_PDM_PCM_RX_UNDERFLOW</ref><sp /><sp /><sp />=<sp />0x08,<sp /></highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc">CYHAL_PDM_PCM_ASYNC_COMPLETE</ref><sp />=<sp />0x10,<sp /></highlight></codeline>
<codeline lineno="121"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref>;</highlight></codeline>
<codeline lineno="122"><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a9b6dc0fbdb5ff94c50d3ea447b2e7729">CYHAL_PDM_PCM_MODE_LEFT</ref>,<sp /><sp /><sp /></highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a10f63e46718c10aefbc64bfda8b82cfd">CYHAL_PDM_PCM_MODE_RIGHT</ref>,<sp /><sp /></highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a3422b29a54a23f1133a62c2b566196dc">CYHAL_PDM_PCM_MODE_STEREO</ref>,<sp /></highlight></codeline>
<codeline lineno="128"><highlight class="normal">}<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac81a68ee166ff48752095f82e6852565">cyhal_pdm_pcm_mode_t</ref>;</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /></codeline>
<codeline lineno="131" refid="structcyhal__pdm__pcm__cfg__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal">{</highlight></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />sample_rate;<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />decimation_rate;<sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac81a68ee166ff48752095f82e6852565">cyhal_pdm_pcm_mode_t</ref><sp />mode;<sp /><sp /></highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />word_length;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="137"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />left_gain;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp />int8_t<sp />right_gain;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline lineno="139"><highlight class="normal">}<sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</ref>;</highlight></codeline>
<codeline lineno="140"><highlight class="normal" /></codeline>
<codeline lineno="142"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp />void<sp />(*<ref kindref="member" refid="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198">cyhal_pdm_pcm_event_callback_t</ref>)(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*handler_arg,<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref><sp />event);</highlight></codeline>
<codeline lineno="143"><highlight class="normal" /></codeline>
<codeline lineno="155"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac2baa0d5162498463cc5228e0ab70909">cyhal_pdm_pcm_init</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin_data,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref><sp />pin_clk,</highlight></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref><sp />*clk_source,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</ref><sp />*cfg);</highlight></codeline>
<codeline lineno="157"><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga89ce18cbdd29884ea093ea413df76c6f">cyhal_pdm_pcm_free</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="164"><highlight class="normal" /></codeline>
<codeline lineno="171"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61">cyhal_pdm_pcm_start</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="172"><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gae3832916c19f3031dddcee394047e499">cyhal_pdm_pcm_stop</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="180"><highlight class="normal" /></codeline>
<codeline lineno="190"><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga70af22e5c029ef0899d14da93253fcc1">cyhal_pdm_pcm_is_enabled</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="191"><highlight class="normal" /></codeline>
<codeline lineno="204"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gad2dc5543b500a97a938d6c642932e772">cyhal_pdm_pcm_set_gain</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp />int8_t<sp />gain_left,<sp />int8_t<sp />gain_right);</highlight></codeline>
<codeline lineno="205"><highlight class="normal" /></codeline>
<codeline lineno="211"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga4f6559e37a2ea3facdffe3cac6241356">cyhal_pdm_pcm_clear</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="212"><highlight class="normal" /></codeline>
<codeline lineno="228"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga5694092b3f4bc66a0a649829d346d1c7">cyhal_pdm_pcm_read</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*data,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />*length);</highlight></codeline>
<codeline lineno="229"><highlight class="normal" /></codeline>
<codeline lineno="246"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031">cyhal_pdm_pcm_read_async</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*data,<sp /></highlight><highlight class="keywordtype">size_t</highlight><highlight class="normal"><sp />length);</highlight></codeline>
<codeline lineno="247"><highlight class="normal" /></codeline>
<codeline lineno="253"><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga9510e6cfe34d3279aaa2fcf015e24288">cyhal_pdm_pcm_is_pending</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="254"><highlight class="normal" /></codeline>
<codeline lineno="260"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga5db8d3906cdd3cd0e2cadcb6a283d910">cyhal_pdm_pcm_abort_async</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="261"><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198">cyhal_pdm_pcm_event_callback_t</ref><sp />callback,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg);</highlight></codeline>
<codeline lineno="271"><highlight class="normal" /></codeline>
<codeline lineno="279"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref><sp />event,<sp />uint8_t<sp />intr_priority,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />enable);</highlight></codeline>
<codeline lineno="280"><highlight class="normal" /></codeline>
<codeline lineno="292"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga2296229eed2643ba0a938c3437c6ce82">cyhal_pdm_pcm_set_async_mode</ref>(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__general__types_1gab2d2acfb82599df54152be0b170c6ec2">cyhal_async_mode_t</ref><sp />mode,<sp />uint8_t<sp />dma_priority);</highlight></codeline>
<codeline lineno="293"><highlight class="normal" /></codeline>
<codeline lineno="294"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="295"><highlight class="normal">}</highlight></codeline>
<codeline lineno="296"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="297"><highlight class="normal" /></codeline>
<codeline lineno="298"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CYHAL_PDMPCM_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="299"><highlight class="normal" /><highlight class="preprocessor">#include<sp />CYHAL_PDMPCM_IMPL_HEADER</highlight><highlight class="normal" /></codeline>
<codeline lineno="300"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CYHAL_PDMPCM_IMPL_HEADER<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="301"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" />
  </compounddef>
</doxygen>